
/* A Bison parser, made by GNU Bison 2.4.1.  */

/* Skeleton implementation for Bison's Yacc-like parsers in C
   
      Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005, 2006
   Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.4.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 1



/* Copy the first part of user declarations.  */

/* Line 189 of yacc.c  */
#line 17 "expr.y"

#include "slb.h"
#include "grecs-locus.h"
#include <math.h>

double round(double x);
double trunc(double x);


static struct grecs_locus_point current_point;
static const char *inbuf;
static const char *curp;
static int input_char;
static int yyeof;

struct slb_node_state {
	struct slb_node_state *next;
	void *node;
	void *key;
	size_t size;
	void *data;
	void (*initfn)(void *);
};

static struct grecs_symtab *parse_vartab;
static struct slb_node *parse_tree;

static int yylex(void);
static void yyerror(char *s);
static struct slb_node *alloc_node(struct grecs_locus_point beg,
				   struct grecs_locus_point end);
static struct function *function_lookup(const char *name, size_t len);

struct daemon_only_closure
{
	struct function *func;
	grecs_locus_t locus;
};

static int
request_daemon_mode_hook(void *ptr)
{
	struct daemon_only_closure *clos = ptr;

	if (!standalone_mode) {
		grecs_error(&clos->locus, 0,
			    "function %s can be used only in standalone mode",
			    clos->func->name);
		return 1;
	}
	return 0;
}



/* Line 189 of yacc.c  */
#line 129 "expr.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 1
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     T_NUMBER = 258,
     T_VARIABLE = 259,
     T_FUNC = 260,
     T_ERR = 261,
     T_EXPR = 262,
     T_OR = 263,
     T_AND = 264,
     T_NOT = 265,
     T_NE = 266,
     T_EQ = 267,
     T_GE = 268,
     T_GT = 269,
     T_LE = 270,
     T_LT = 271,
     T_UMINUS = 272,
     T_POW = 273
   };
#endif
/* Tokens.  */
#define T_NUMBER 258
#define T_VARIABLE 259
#define T_FUNC 260
#define T_ERR 261
#define T_EXPR 262
#define T_OR 263
#define T_AND 264
#define T_NOT 265
#define T_NE 266
#define T_EQ 267
#define T_GE 268
#define T_GT 269
#define T_LE 270
#define T_LT 271
#define T_UMINUS 272
#define T_POW 273




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 214 of yacc.c  */
#line 96 "expr.y"

	double number;
	struct slb_varref *var;
	struct slb_node *node;
	struct function *func;
	struct slb_node_list list;
	struct { const char *name; size_t len; } expr;



/* Line 214 of yacc.c  */
#line 212 "expr.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif

#if ! defined YYLTYPE && ! defined YYLTYPE_IS_DECLARED
typedef struct YYLTYPE
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} YYLTYPE;
# define yyltype YYLTYPE /* obsolescent; will be withdrawn */
# define YYLTYPE_IS_DECLARED 1
# define YYLTYPE_IS_TRIVIAL 1
#endif


/* Copy the second part of user declarations.  */


/* Line 264 of yacc.c  */
#line 237 "expr.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef _STDLIB_H
#      define _STDLIB_H 1
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined _STDLIB_H \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef _STDLIB_H
#    define _STDLIB_H 1
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined _STDLIB_H && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYLTYPE_IS_TRIVIAL && YYLTYPE_IS_TRIVIAL \
	     && defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
  YYLTYPE yyls_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE) + sizeof (YYLTYPE)) \
      + 2 * YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  21
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   140

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  29
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  10
/* YYNRULES -- Number of rules.  */
#define YYNRULES  36
/* YYNRULES -- Number of states.  */
#define YYNSTATES  63

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   273

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
      26,    27,    20,    18,    25,    19,     2,    21,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    28,     2,
       2,     8,     2,    24,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    22,    23
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint8 yyprhs[] =
{
       0,     0,     3,     5,     7,    11,    15,    19,    23,    27,
      31,    35,    39,    43,    47,    51,    55,    59,    63,    66,
      69,    72,    76,    82,    84,    86,    88,    92,    93,    95,
      97,    99,   101,   106,   107,   109,   111
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int8 yyrhs[] =
{
      30,     0,    -1,    31,    -1,    32,    -1,    31,    25,    32,
      -1,    32,    13,    32,    -1,    32,    12,    32,    -1,    32,
      17,    32,    -1,    32,    16,    32,    -1,    32,    15,    32,
      -1,    32,    14,    32,    -1,    32,     9,    32,    -1,    32,
      10,    32,    -1,    32,    18,    32,    -1,    32,    19,    32,
      -1,    32,    20,    32,    -1,    32,    21,    32,    -1,    32,
      23,    32,    -1,    19,    32,    -1,    18,    32,    -1,    11,
      32,    -1,    26,    32,    27,    -1,    32,    24,    34,    28,
      32,    -1,    36,    -1,    35,    -1,    33,    -1,     4,     8,
      32,    -1,    -1,    32,    -1,     3,    -1,     4,    -1,     7,
      -1,     5,    26,    37,    27,    -1,    -1,    38,    -1,    32,
      -1,    38,    25,    32,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   107,   107,   119,   125,   133,   140,   147,   154,   161,
     168,   175,   182,   189,   196,   203,   210,   217,   224,   230,
     234,   240,   244,   252,   253,   254,   257,   267,   270,   273,
     279,   285,   295,   323,   327,   330,   336
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "T_NUMBER", "T_VARIABLE", "T_FUNC",
  "T_ERR", "T_EXPR", "'='", "T_OR", "T_AND", "T_NOT", "T_NE", "T_EQ",
  "T_GE", "T_GT", "T_LE", "T_LT", "'+'", "'-'", "'*'", "'/'", "T_UMINUS",
  "T_POW", "'?'", "','", "'('", "')'", "':'", "$accept", "input", "elst",
  "expr", "asgn", "opte", "atom", "func", "args", "argl", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,    61,   263,
     264,   265,   266,   267,   268,   269,   270,   271,    43,    45,
      42,    47,   272,   273,    63,    44,    40,    41,    58
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,    29,    30,    31,    31,    32,    32,    32,    32,    32,
      32,    32,    32,    32,    32,    32,    32,    32,    32,    32,
      32,    32,    32,    32,    32,    32,    33,    34,    34,    35,
      35,    35,    36,    37,    37,    38,    38
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     2,     2,
       2,     3,     5,     1,     1,     1,     3,     0,     1,     1,
       1,     1,     4,     0,     1,     1,     3
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
       0,    29,    30,     0,    31,     0,     0,     0,     0,     0,
       2,     3,    25,    24,    23,     0,    33,    20,    19,    18,
       0,     1,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    27,    26,    35,     0,
      34,    21,     4,    11,    12,     6,     5,    10,     9,     8,
       7,    13,    14,    15,    16,    17,    28,     0,    32,     0,
       0,    36,    22
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
      -1,     9,    10,    11,    12,    57,    13,    14,    39,    40
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -18
static const yytype_int8 yypact[] =
{
      30,   -18,    -2,   -17,   -18,    30,    30,    30,    30,    14,
     -10,    64,   -18,   -18,   -18,    30,    30,    92,   -11,   -11,
      48,   -18,    30,    30,    30,    30,    30,    30,    30,    30,
      30,    30,    30,    30,    30,    30,    30,    64,    64,     5,
      -9,   -18,    64,    79,    92,   105,   105,   116,   116,   116,
     116,   -16,   -16,   -11,   -11,   -11,    64,     8,   -18,    30,
      30,    64,   -18
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -18,   -18,   -18,    -5,   -18,   -18,   -18,   -18,   -18,   -18
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const yytype_int8 yytable[] =
{
      17,    18,    19,    20,    33,    34,    15,    35,    36,    16,
      37,    38,    35,    36,    21,    22,    59,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    58,     1,     2,     3,    60,     4,     0,     0,
       0,     5,     0,     0,     0,     0,     0,     0,     6,     7,
       0,     0,     0,     0,    61,    62,     8,    23,    24,     0,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
       0,    35,    36,    23,    24,    41,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,     0,    35,    36,    24,
       0,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,     0,    35,    36,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,     0,    35,    36,    -1,    -1,    27,
      28,    29,    30,    31,    32,    33,    34,     0,    35,    36,
      -1,    -1,    -1,    -1,    31,    32,    33,    34,     0,    35,
      36
};

static const yytype_int8 yycheck[] =
{
       5,     6,     7,     8,    20,    21,     8,    23,    24,    26,
      15,    16,    23,    24,     0,    25,    25,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    27,     3,     4,     5,    28,     7,    -1,    -1,
      -1,    11,    -1,    -1,    -1,    -1,    -1,    -1,    18,    19,
      -1,    -1,    -1,    -1,    59,    60,    26,     9,    10,    -1,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      -1,    23,    24,     9,    10,    27,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    -1,    23,    24,    10,
      -1,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    -1,    23,    24,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    -1,    23,    24,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    -1,    23,    24,
      14,    15,    16,    17,    18,    19,    20,    21,    -1,    23,
      24
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,     3,     4,     5,     7,    11,    18,    19,    26,    30,
      31,    32,    33,    35,    36,     8,    26,    32,    32,    32,
      32,     0,    25,     9,    10,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    23,    24,    32,    32,    37,
      38,    27,    32,    32,    32,    32,    32,    32,    32,    32,
      32,    32,    32,    32,    32,    32,    32,    34,    27,    25,
      28,    32,    32
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
	      (Loc).first_line, (Loc).first_column,	\
	      (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value, Location); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (!yyvaluep)
    return;
  YYUSE (yylocationp);
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep, YYLTYPE const * const yylocationp)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep, yylocationp)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
    YYLTYPE const * const yylocationp;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  YY_LOCATION_PRINT (yyoutput, *yylocationp);
  YYFPRINTF (yyoutput, ": ");
  yy_symbol_value_print (yyoutput, yytype, yyvaluep, yylocationp);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, YYLTYPE *yylsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yylsp, yyrule)
    YYSTYPE *yyvsp;
    YYLTYPE *yylsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       , &(yylsp[(yyi + 1) - (yynrhs)])		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, yylsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into YYRESULT an error message about the unexpected token
   YYCHAR while in state YYSTATE.  Return the number of bytes copied,
   including the terminating null byte.  If YYRESULT is null, do not
   copy anything; just return the number of bytes that would be
   copied.  As a special case, return 0 if an ordinary "syntax error"
   message will do.  Return YYSIZE_MAXIMUM if overflow occurs during
   size calculation.  */
static YYSIZE_T
yysyntax_error (char *yyresult, int yystate, int yychar)
{
  int yyn = yypact[yystate];

  if (! (YYPACT_NINF < yyn && yyn <= YYLAST))
    return 0;
  else
    {
      int yytype = YYTRANSLATE (yychar);
      YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
      YYSIZE_T yysize = yysize0;
      YYSIZE_T yysize1;
      int yysize_overflow = 0;
      enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
      char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
      int yyx;

# if 0
      /* This is so xgettext sees the translatable formats that are
	 constructed on the fly.  */
      YY_("syntax error, unexpected %s");
      YY_("syntax error, unexpected %s, expecting %s");
      YY_("syntax error, unexpected %s, expecting %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s");
      YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
# endif
      char *yyfmt;
      char const *yyf;
      static char const yyunexpected[] = "syntax error, unexpected %s";
      static char const yyexpecting[] = ", expecting %s";
      static char const yyor[] = " or %s";
      char yyformat[sizeof yyunexpected
		    + sizeof yyexpecting - 1
		    + ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
		       * (sizeof yyor - 1))];
      char const *yyprefix = yyexpecting;

      /* Start YYX at -YYN if negative to avoid negative indexes in
	 YYCHECK.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;

      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yycount = 1;

      yyarg[0] = yytname[yytype];
      yyfmt = yystpcpy (yyformat, yyunexpected);

      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	  {
	    if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
	      {
		yycount = 1;
		yysize = yysize0;
		yyformat[sizeof yyunexpected - 1] = '\0';
		break;
	      }
	    yyarg[yycount++] = yytname[yyx];
	    yysize1 = yysize + yytnamerr (0, yytname[yyx]);
	    yysize_overflow |= (yysize1 < yysize);
	    yysize = yysize1;
	    yyfmt = yystpcpy (yyfmt, yyprefix);
	    yyprefix = yyor;
	  }

      yyf = YY_(yyformat);
      yysize1 = yysize + yystrlen (yyf);
      yysize_overflow |= (yysize1 < yysize);
      yysize = yysize1;

      if (yysize_overflow)
	return YYSIZE_MAXIMUM;

      if (yyresult)
	{
	  /* Avoid sprintf, as that infringes on the user's name space.
	     Don't have undefined behavior even if the translation
	     produced a string with the wrong number of "%s"s.  */
	  char *yyp = yyresult;
	  int yyi = 0;
	  while ((*yyp = *yyf) != '\0')
	    {
	      if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		{
		  yyp += yytnamerr (yyp, yyarg[yyi++]);
		  yyf += 2;
		}
	      else
		{
		  yyp++;
		  yyf++;
		}
	    }
	}
      return yysize;
    }
}
#endif /* YYERROR_VERBOSE */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep, YYLTYPE *yylocationp)
#else
static void
yydestruct (yymsg, yytype, yyvaluep, yylocationp)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
    YYLTYPE *yylocationp;
#endif
{
  YYUSE (yyvaluep);
  YYUSE (yylocationp);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}

/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Location data for the lookahead symbol.  */
YYLTYPE yylloc;

/* Number of syntax errors so far.  */
int yynerrs;



/*-------------------------.
| yyparse or yypush_parse.  |
`-------------------------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{


    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.
       `yyls': related to locations.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    /* The location stack.  */
    YYLTYPE yylsa[YYINITDEPTH];
    YYLTYPE *yyls;
    YYLTYPE *yylsp;

    /* The locations where the error started and ended.  */
    YYLTYPE yyerror_range[2];

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;
  YYLTYPE yyloc;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N), yylsp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yyls = yylsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;
  yylsp = yyls;

#if YYLTYPE_IS_TRIVIAL
  /* Initialize the default location before parsing starts.  */
  yylloc.first_line   = yylloc.last_line   = 1;
  yylloc.first_column = yylloc.last_column = 1;
#endif

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;
	YYLTYPE *yyls1 = yyls;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yyls1, yysize * sizeof (*yylsp),
		    &yystacksize);

	yyls = yyls1;
	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
	YYSTACK_RELOCATE (yyls_alloc, yyls);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;
      yylsp = yyls + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;
  *++yylsp = yylloc;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];

  /* Default location.  */
  YYLLOC_DEFAULT (yyloc, (yylsp - yylen), yylen);
  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:

/* Line 1455 of yacc.c  */
#line 108 "expr.y"
    {
	       if ((yyvsp[(1) - (1)].list).count == 1)
		       parse_tree = (yyvsp[(1) - (1)].list).head;
	       else {
		       parse_tree = alloc_node((yylsp[(1) - (1)]).beg, (yylsp[(1) - (1)]).end);
		       parse_tree->n_type = node_list;
		       parse_tree->n_next = (yyvsp[(1) - (1)].list).head;
	       }
       }
    break;

  case 3:

/* Line 1455 of yacc.c  */
#line 120 "expr.y"
    {
	       (yyvsp[(1) - (1)].node)->n_next = NULL;
	       (yyval.list).head = (yyval.list).tail = (yyvsp[(1) - (1)].node);
	       (yyval.list).count = 1;
       }
    break;

  case 4:

/* Line 1455 of yacc.c  */
#line 126 "expr.y"
    {
	       (yyval.list).tail->n_next = (yyvsp[(3) - (3)].node);
	       (yyval.list).tail = (yyvsp[(3) - (3)].node);
	       (yyval.list).count++;
       }
    break;

  case 5:

/* Line 1455 of yacc.c  */
#line 134 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (3)]).beg, (yylsp[(3) - (3)]).end);
	       (yyval.node)->n_type = node_eq;
	       (yyval.node)->v.n_arg[0] = (yyvsp[(1) - (3)].node);
	       (yyval.node)->v.n_arg[1] = (yyvsp[(3) - (3)].node);
       }
    break;

  case 6:

/* Line 1455 of yacc.c  */
#line 141 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (3)]).beg, (yylsp[(3) - (3)]).end);
	       (yyval.node)->n_type = node_ne;
	       (yyval.node)->v.n_arg[0] = (yyvsp[(1) - (3)].node);
	       (yyval.node)->v.n_arg[1] = (yyvsp[(3) - (3)].node);
       }
    break;

  case 7:

/* Line 1455 of yacc.c  */
#line 148 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (3)]).beg, (yylsp[(3) - (3)]).end);
	       (yyval.node)->n_type = node_lt;
	       (yyval.node)->v.n_arg[0] = (yyvsp[(1) - (3)].node);
	       (yyval.node)->v.n_arg[1] = (yyvsp[(3) - (3)].node);
       }
    break;

  case 8:

/* Line 1455 of yacc.c  */
#line 155 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (3)]).beg, (yylsp[(3) - (3)]).end);
	       (yyval.node)->n_type = node_le;
	       (yyval.node)->v.n_arg[0] = (yyvsp[(1) - (3)].node);
	       (yyval.node)->v.n_arg[1] = (yyvsp[(3) - (3)].node);
       }
    break;

  case 9:

/* Line 1455 of yacc.c  */
#line 162 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (3)]).beg, (yylsp[(3) - (3)]).end);
	       (yyval.node)->n_type = node_gt;
	       (yyval.node)->v.n_arg[0] = (yyvsp[(1) - (3)].node);
	       (yyval.node)->v.n_arg[1] = (yyvsp[(3) - (3)].node);
       }
    break;

  case 10:

/* Line 1455 of yacc.c  */
#line 169 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (3)]).beg, (yylsp[(3) - (3)]).end);
	       (yyval.node)->n_type = node_ge;
	       (yyval.node)->v.n_arg[0] = (yyvsp[(1) - (3)].node);
	       (yyval.node)->v.n_arg[1] = (yyvsp[(3) - (3)].node);
       }
    break;

  case 11:

/* Line 1455 of yacc.c  */
#line 176 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (3)]).beg, (yylsp[(3) - (3)]).end);
	       (yyval.node)->n_type = node_or;
	       (yyval.node)->v.n_arg[0] = (yyvsp[(1) - (3)].node);
	       (yyval.node)->v.n_arg[1] = (yyvsp[(3) - (3)].node);
       }
    break;

  case 12:

/* Line 1455 of yacc.c  */
#line 183 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (3)]).beg, (yylsp[(3) - (3)]).end);
	       (yyval.node)->n_type = node_and;
	       (yyval.node)->v.n_arg[0] = (yyvsp[(1) - (3)].node);
	       (yyval.node)->v.n_arg[1] = (yyvsp[(3) - (3)].node);
       }
    break;

  case 13:

/* Line 1455 of yacc.c  */
#line 190 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (3)]).beg, (yylsp[(3) - (3)]).end);
	       (yyval.node)->n_type = node_add;
	       (yyval.node)->v.n_arg[0] = (yyvsp[(1) - (3)].node);
	       (yyval.node)->v.n_arg[1] = (yyvsp[(3) - (3)].node);
       }
    break;

  case 14:

/* Line 1455 of yacc.c  */
#line 197 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (3)]).beg, (yylsp[(3) - (3)]).end);
	       (yyval.node)->n_type = node_sub;
	       (yyval.node)->v.n_arg[0] = (yyvsp[(1) - (3)].node);
	       (yyval.node)->v.n_arg[1] = (yyvsp[(3) - (3)].node);
       }
    break;

  case 15:

/* Line 1455 of yacc.c  */
#line 204 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (3)]).beg, (yylsp[(3) - (3)]).end);
	       (yyval.node)->n_type = node_mul;
	       (yyval.node)->v.n_arg[0] = (yyvsp[(1) - (3)].node);
	       (yyval.node)->v.n_arg[1] = (yyvsp[(3) - (3)].node);
       }
    break;

  case 16:

/* Line 1455 of yacc.c  */
#line 211 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (3)]).beg, (yylsp[(3) - (3)]).end);
	       (yyval.node)->n_type = node_div;
	       (yyval.node)->v.n_arg[0] = (yyvsp[(1) - (3)].node);
	       (yyval.node)->v.n_arg[1] = (yyvsp[(3) - (3)].node);
       }
    break;

  case 17:

/* Line 1455 of yacc.c  */
#line 218 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (3)]).beg, (yylsp[(3) - (3)]).end);
	       (yyval.node)->n_type = node_pow;
	       (yyval.node)->v.n_arg[0] = (yyvsp[(1) - (3)].node);
	       (yyval.node)->v.n_arg[1] = (yyvsp[(3) - (3)].node);
       }
    break;

  case 18:

/* Line 1455 of yacc.c  */
#line 225 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (2)]).beg, (yylsp[(2) - (2)]).end);
	       (yyval.node)->n_type = node_uminus;
	       (yyval.node)->v.n_arg[0] = (yyvsp[(2) - (2)].node);
       }
    break;

  case 19:

/* Line 1455 of yacc.c  */
#line 231 "expr.y"
    {
	       (yyval.node) = (yyvsp[(2) - (2)].node);
       }
    break;

  case 20:

/* Line 1455 of yacc.c  */
#line 235 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (2)]).beg, (yylsp[(2) - (2)]).end);
	       (yyval.node)->n_type = node_not;
	       (yyval.node)->v.n_arg[0] = (yyvsp[(2) - (2)].node);
       }
    break;

  case 21:

/* Line 1455 of yacc.c  */
#line 241 "expr.y"
    {
	       (yyval.node) = (yyvsp[(2) - (3)].node);
       }
    break;

  case 22:

/* Line 1455 of yacc.c  */
#line 245 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (5)]).beg, (yylsp[(5) - (5)]).end);
	       (yyval.node)->n_type = node_cond;
	       (yyval.node)->v.n_arg[0] = (yyvsp[(1) - (5)].node);
	       (yyval.node)->v.n_arg[1] = (yyvsp[(3) - (5)].node);
	       (yyval.node)->v.n_arg[2] = (yyvsp[(5) - (5)].node);
       }
    break;

  case 26:

/* Line 1455 of yacc.c  */
#line 258 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (3)]).beg, (yylsp[(3) - (3)]).end);
	       (yyval.node)->n_type = node_asgn;
	       (yyval.node)->v.n_asgn.var = (yyvsp[(1) - (3)].var);
	       (yyval.node)->v.n_asgn.expr = (yyvsp[(3) - (3)].node);
       }
    break;

  case 27:

/* Line 1455 of yacc.c  */
#line 267 "expr.y"
    {
	       (yyval.node) = NULL;
       }
    break;

  case 29:

/* Line 1455 of yacc.c  */
#line 274 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (1)]).beg, (yylsp[(1) - (1)]).end);
	       (yyval.node)->n_type = node_const;
	       (yyval.node)->v.n_const = (yyvsp[(1) - (1)].number);
       }
    break;

  case 30:

/* Line 1455 of yacc.c  */
#line 280 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (1)]).beg, (yylsp[(1) - (1)]).end);
	       (yyval.node)->n_type = node_variable;
	       (yyval.node)->v.n_var = (yyvsp[(1) - (1)].var);
       }
    break;

  case 31:

/* Line 1455 of yacc.c  */
#line 286 "expr.y"
    {
	       (yyval.node) = alloc_node((yylsp[(1) - (1)]).beg, (yylsp[(1) - (1)]).end);
	       (yyval.node)->n_type = node_subexpr;
	       (yyval.node)->v.n_expr.name = grecs_malloc((yyvsp[(1) - (1)].expr).len + 1);
	       memcpy((yyval.node)->v.n_expr.name, (yyvsp[(1) - (1)].expr).name, (yyvsp[(1) - (1)].expr).len + 1);
	       (yyval.node)->v.n_expr.name[(yyvsp[(1) - (1)].expr).len] = 0;
       }
    break;

  case 32:

/* Line 1455 of yacc.c  */
#line 296 "expr.y"
    {
	       if ((yyvsp[(3) - (4)].list).count < (yyvsp[(1) - (4)].func)->minargs) {
		       grecs_error(&(yylsp[(1) - (4)]), 0, "too few arguments in call to %s",
				   (yyvsp[(1) - (4)].func)->name);
		       YYERROR;
	       } else if ((yyvsp[(3) - (4)].list).count > (yyvsp[(1) - (4)].func)->maxargs) {
		       grecs_error(&(yylsp[(1) - (4)]), 0, "too many arguments in call to %s",
				   (yyvsp[(1) - (4)].func)->name);
		       YYERROR;
	       } 
	       if ((yyvsp[(1) - (4)].func)->flags & FUN_DAEMON_ONLY) {
		       struct daemon_only_closure *p = grecs_malloc(sizeof(*p));
		       p->func = (yyvsp[(1) - (4)].func);
		       p->locus = (yylsp[(1) - (4)]);
		       add_config_finish_hook(request_daemon_mode_hook, p);
	       }

	       (yyval.node) = alloc_node((yylsp[(1) - (4)]).beg, (yylsp[(4) - (4)]).end);
	       (yyval.node)->n_type = node_func;
	       (yyval.node)->n_min_eval = (yyvsp[(1) - (4)].func)->min_eval;
	       (yyval.node)->v.n_func.func = (yyvsp[(1) - (4)].func)->func;
	       (yyval.node)->v.n_func.args = (yyvsp[(3) - (4)].list).head;
	       (yyval.node)->v.n_func.nargs = (yyvsp[(3) - (4)].list).count;
       }
    break;

  case 33:

/* Line 1455 of yacc.c  */
#line 323 "expr.y"
    {
	       (yyval.list).head = (yyval.list).tail = NULL;
	       (yyval.list).count = 0;
       }
    break;

  case 35:

/* Line 1455 of yacc.c  */
#line 331 "expr.y"
    {
	       (yyvsp[(1) - (1)].node)->n_next = NULL;
	       (yyval.list).head = (yyval.list).tail = (yyvsp[(1) - (1)].node);
	       (yyval.list).count = 1;
       }
    break;

  case 36:

/* Line 1455 of yacc.c  */
#line 337 "expr.y"
    {
	       (yyvsp[(1) - (3)].list).tail->n_next = (yyvsp[(3) - (3)].node);
	       (yyvsp[(1) - (3)].list).tail = (yyvsp[(3) - (3)].node);
	       (yyvsp[(1) - (3)].list).count++;
	       (yyval.list) = (yyvsp[(1) - (3)].list);
       }
    break;



/* Line 1455 of yacc.c  */
#line 1892 "expr.c"
      default: break;
    }
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;
  *++yylsp = yyloc;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
      {
	YYSIZE_T yysize = yysyntax_error (0, yystate, yychar);
	if (yymsg_alloc < yysize && yymsg_alloc < YYSTACK_ALLOC_MAXIMUM)
	  {
	    YYSIZE_T yyalloc = 2 * yysize;
	    if (! (yysize <= yyalloc && yyalloc <= YYSTACK_ALLOC_MAXIMUM))
	      yyalloc = YYSTACK_ALLOC_MAXIMUM;
	    if (yymsg != yymsgbuf)
	      YYSTACK_FREE (yymsg);
	    yymsg = (char *) YYSTACK_ALLOC (yyalloc);
	    if (yymsg)
	      yymsg_alloc = yyalloc;
	    else
	      {
		yymsg = yymsgbuf;
		yymsg_alloc = sizeof yymsgbuf;
	      }
	  }

	if (0 < yysize && yysize <= yymsg_alloc)
	  {
	    (void) yysyntax_error (yymsg, yystate, yychar);
	    yyerror (yymsg);
	  }
	else
	  {
	    yyerror (YY_("syntax error"));
	    if (yysize != 0)
	      goto yyexhaustedlab;
	  }
      }
#endif
    }

  yyerror_range[0] = yylloc;

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval, &yylloc);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  yyerror_range[0] = yylsp[1-yylen];
  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      yyerror_range[0] = *yylsp;
      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp, yylsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;

  yyerror_range[1] = yylloc;
  /* Using YYLLOC is tempting, but would change the location of
     the lookahead.  YYLOC is available though.  */
  YYLLOC_DEFAULT (yyloc, (yyerror_range - 1), 2);
  *++yylsp = yyloc;

  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval, &yylloc);
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp, yylsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



/* Line 1675 of yacc.c  */
#line 345 "expr.y"


void
yyerror(char *s)
{
	grecs_error(&yylloc, 0, "%s", s);
}

static int
input()
{
	if (yyeof)
		input_char = 0;
	else if (curp) {
		input_char = *curp;
		if (!input_char) 
			yyeof++;
		else {
			curp++;
			if (input_char == '\n') {
				current_point.line++;
				current_point.col = 1;
			} else
				current_point.col++;
		}
	}
	return input_char;
}

static void
unput()
{
	if (yyeof)
		return;
	if (curp > inbuf)
		--curp;
	if (curp > inbuf)
		input_char = curp[-1];
	if (input_char == '\n') {
		const char *p;
		
		current_point.line--;
		for (p = curp, current_point.col = 1; p > inbuf && *p != '\n';
		     current_point.col++);
	} else
		current_point.col--;
}

static int
yylex()
{
	/* Skip whitespace */
	while (input() && isspace(input_char))
		;
	if (!input_char)
		return 0;

	yylloc.beg = current_point;
	yylloc.beg.col--;
	yylloc.end = yylloc.beg;
		
	/*
	 * A number
	 */
	if (isdigit(input_char)) {
		const char *p;
			
		yylval.number = strtod(curp - 1, (char**)&p);
		debug(SLB_DEBCAT_ELEX, 1,
		      ("yylex: NUMBER %f", yylval.number));
		current_point.col += p - curp;
		yylloc.end = current_point;
		curp = p;
		return T_NUMBER;
	}

	if (isalpha(input_char) || input_char == '_') {
		const char *p = curp - 1;
		size_t len = 1;
		struct function *fp;
		int install;
		
		while (input() &&
		       (isalpha(input_char) || input_char == '_' ||
			isdigit(input_char)))
			len++;
		unput();
		yylloc.end = current_point;
		
		fp = function_lookup(p, len);
		if (fp) {
			yylval.func = fp;
			debug(SLB_DEBCAT_ELEX, 1,
			      ("yylex: FUNC: %.*s", len, p));
			return T_FUNC;
		}

		install = 1;
		yylval.var = varref_lookup(parse_vartab, p, len, &install);
		debug(SLB_DEBCAT_ELEX, 1,
		      ("yylex: VARIABLE: %.*s", len, p));
		return T_VARIABLE;
	}

	if (input_char == '@') {
		const char *p = curp;
		size_t len = 0;
		
		while (input() &&
		       (isalpha(input_char) || input_char == '_' ||
			isdigit(input_char)))
			len++;
		unput();
		yylloc.end = current_point;
		
		yylval.expr.name = p;
		yylval.expr.len = len;
		return T_EXPR;
	}
	
	/*
	 * Boolean expressions
	 */
	if (input_char == '&' || input_char == '|') {
		int c = input_char;

		if (input() == c) {
			debug(SLB_DEBCAT_ELEX, 1,
			      ("yylex: %s",
			       input_char == '&' ? "AND" : "OR"));
			yylloc.end = current_point;
			return input_char == '&' ? T_AND : T_OR;
		}
		unput();
		yylloc.end = current_point;
		
		debug(SLB_DEBCAT_ELEX, 1, ("yylex: %c", c));
		return c;
	}

	/*
	 * Comparison operator
	 */
	if (strchr("<>=!", input_char)) {
		int c = input_char;
		if (input() == '=') {
			switch (c) {
			case '<':
				debug(SLB_DEBCAT_ELEX, 1, ("yylex: LE"));
				yylloc.end = current_point;
				return T_LE;
			case '>':
				debug(SLB_DEBCAT_ELEX, 1, ("yylex: GE"));
				yylloc.end = current_point;
				return T_GE;
			case '=':
				debug(SLB_DEBCAT_ELEX, 1, ("yylex: EQ"));
				yylloc.end = current_point;
				return T_EQ;
			case '!':
				debug(SLB_DEBCAT_ELEX, 1, ("yylex: NE"));
				yylloc.end = current_point;
				return T_NE;
			}
		} else {
			unput();
			yylloc.end = current_point;
			switch (c) {
			case '<':
				debug(SLB_DEBCAT_ELEX, 1, ("yylex: LT"));
				return T_LT;
			case '>':
				debug(SLB_DEBCAT_ELEX, 1, ("yylex: GT"));
				return T_GT;
			case '!':
				debug(SLB_DEBCAT_ELEX, 1, ("yylex: NOT"));
				return T_NOT;
			default:
				debug(SLB_DEBCAT_ELEX, 1, ("yylex: %c", c));
				return c;
			}
		}
	}

	/*
	 * Power or multiplication
	 */
	if (input_char == '*') {
		if (input() == '*') {
			debug(SLB_DEBCAT_ELEX, 1, ("yylex: **"));
			yylloc.end = current_point;
			return T_POW;
		}
		unput();
	}
	
	debug(SLB_DEBCAT_ELEX, 1, ("yylex: %c", input_char));
	yylloc.end = current_point;
	return input_char;
}

int
compile_expression(const char *text, grecs_locus_t *locus,
		   struct slb_expression **pexpr)
{
	int rc;
	
	inbuf = curp = text;
	yyeof = 0;
	yylloc = *locus;
	current_point = yylloc.beg;
	parse_tree = NULL;
	parse_vartab = grecs_symtab_create_default(sizeof(struct slb_varref));

	yydebug = debug_level[SLB_DEBCAT_EGRAM];
	rc = yyparse();

	if (rc == 0) {
		struct slb_expression *expr = grecs_zalloc(sizeof(*expr));
		expr->ex_name = NULL;
		expr->ex_text = grecs_strdup(text);
		if (locus) 
			expr->ex_locus = *locus;
		else
			memset(&expr->ex_locus, 0, sizeof(expr->ex_locus));
		/* FIXME: Optimize parse_tree */
		expr->ex_tree = parse_tree;
		expr->ex_vartab = parse_vartab;
		*pexpr = expr;
	} else {
		grecs_symtab_free(parse_vartab);
		parse_vartab = NULL;
	}
	return rc;
}
			
static struct slb_node *
alloc_node(struct grecs_locus_point beg, struct grecs_locus_point end)
{
	struct slb_node *p = grecs_zalloc(sizeof(*p));
	p->n_locus.beg = beg;
	p->n_locus.end = end;
	p->n_type = node_unknown;
	return p;
}


void *
get_node_state(struct slb_node_state **ps, struct slb_node *node,
	       void *key, size_t size, void (*initfn)(void*))
{
	struct slb_node_state *ns;

	if (*ps) {
		for (ns = *ps; ns; ns = ns->next) {
			if (ns->node == node && ns->key == key &&
			    ns->size == size)
				return ns->data;
		}
	}
	ns = grecs_malloc(sizeof(*ns));
	ns->data = grecs_zalloc(size);
	ns->initfn = initfn;
	if (initfn)
		initfn(ns->data);
	ns->node = node;
	ns->key = key;
	ns->size = size;
	ns->next = *ps;
	*ps = ns;
	return ns->data;
}

void
slb_node_state_init(struct slb_node_state *ns)
{
	for (; ns; ns = ns->next)
		if (ns->initfn)
			ns->initfn(ns->data);
}
		

struct prev_val {
	int init;
	double val;
	time_t ts;
	unsigned long serial;
};

static void
init_d(void *p)
{
	struct prev_val *pv = p;
	pv->init = 0;
}

int
func_d(struct slb_node_state **pstate, struct slb_node *node,
       int nargs, double *args, double *res)
{
	struct prev_val *pv = get_node_state(pstate, node, func_d,
					     sizeof(*pv), init_d);

	if (!pv->init) {
		pv->init = 1;
		*res = 0;
	/* There is no optimizer so far, so the same function can
	   be called several times for the same node.  Make sure it
	   returns the same result.
	   FIXME: Implement optimizer. */
	} else if (pv->serial == slb_loop_serial) {
		*res = pv->val;
		return 0;
	} else
		*res = (*args - pv->val) / (slb_loop_ts - pv->ts);
	pv->val = *args;
	pv->ts = slb_loop_ts;
	pv->serial = slb_loop_serial;

	return 0;
}

int
func_max(struct slb_node_state **pstate, struct slb_node *node,
	 int nargs, double *args, double *res)
{
	double x = args[0];
	int i;

	for (i = 1; i < nargs; i++)
		if (args[i] > x)
			x = args[i];
	*res = x;
	return 0;
}

int
func_min(struct slb_node_state **pstate, struct slb_node *node,
	 int nargs, double *args, double *res)
{
	double x = args[0];
	int i;

	for (i = 1; i < nargs; i++)
		if (args[i] < x)
			x = args[i];
	*res = x;
	return 0;
}

int
func_avg(struct slb_node_state **pstate, struct slb_node *node,
	 int nargs, double *args, double *res)
{
	double x = 0;
	int i;

	for (i = 0; i < nargs; i++)
		x += args[i];
	*res = x / nargs;
	return 0;
}

int
func_log(struct slb_node_state **pstate, struct slb_node *node,
	 int nargs, double *args, double *res)
{
	*res = log(*args);
	return 0;
}

int
func_log10(struct slb_node_state **pstate, struct slb_node *node,
	 int nargs, double *args, double *res)
{
	*res = log10(*args);
	return 0;
}

int
func_exp(struct slb_node_state **pstate, struct slb_node *node,
	 int nargs, double *args, double *res)
{
	*res = exp(*args);
	return 0;
}

int
func_pow(struct slb_node_state **pstate, struct slb_node *node,
	 int nargs, double *args, double *res)
{
	*res = pow(args[0], args[1]);
	return 0;
}

int
func_sqrt(struct slb_node_state **pstate, struct slb_node *node,
	  int nargs, double *args, double *res)
{
	*res = sqrt(args[0]);
	return 0;
}

int
func_abs(struct slb_node_state **pstate, struct slb_node *node,
	 int nargs, double *args, double *res)
{
	*res = fabs(args[0]);
	return 0;
}

int
func_ceil(struct slb_node_state **pstate, struct slb_node *node,
	  int nargs, double *args, double *res)
{
	*res = ceil(args[0]);
	return 0;
}

int
func_floor(struct slb_node_state **pstate, struct slb_node *node,
	   int nargs, double *args, double *res)
{
	*res = floor(args[0]);
	return 0;
}

int
func_round(struct slb_node_state **pstate, struct slb_node *node,
	   int nargs, double *args, double *res)
{
	*res = round(args[0]);
	return 0;
}

int
func_trunc(struct slb_node_state **pstate, struct slb_node *node,
	   int nargs, double *args, double *res)
{
	*res = trunc(args[0]);
	return 0;
}


struct function functab[] = {
	{ "d", func_d, 1, 1, FUN_DAEMON_ONLY, 1 },
	{ "max", func_max, 2, SLB_MAX_ARGS },
	{ "min", func_min, 2, SLB_MAX_ARGS },
	{ "avg", func_avg, 2, SLB_MAX_ARGS },
	{ "log", func_log, 1, 1 },
	{ "log10", func_log10, 1, 1 },
	{ "pow", func_pow, 2, 2 },
	{ "sqrt", func_sqrt, 1, 1 },
	{ "abs", func_abs, 1, 1 },
	{ "ceil", func_ceil, 1, 1 },
	{ "floor", func_floor, 1, 1 },
	{ "trunc", func_trunc, 1, 1 },
	{ "round", func_round, 1, 1 },
	{ "exp", func_exp, 1, 1 },
	{ NULL }
};

static struct function *
function_lookup(const char *name, size_t len)
{
	struct function *fp;

	for (fp = functab; fp->name; fp++) {
		if (strlen(fp->name) == len &&
		    memcmp(fp->name, name, len) == 0)
			return fp;
	}
	return NULL;
}


#define EVT_NUMBER  0
#define EVT_BOOLEAN 1

struct eval_result {
	int type;
	union {
		int boolean;
		double number;
	} v;
};

static int
to_boolean(struct eval_result *res)
{
	switch (res->type) {
	case EVT_NUMBER:
		return res->v.number;

	case EVT_BOOLEAN:
		return res->v.boolean;
	}
	abort();
}

static double
to_number(struct eval_result *res)
{
	switch (res->type) {
	case EVT_NUMBER:
		return res->v.number;

	case EVT_BOOLEAN:
		return res->v.boolean;
	}
	abort();
}

static int
evalnode(struct slb_node *node, struct slb_node_state **pstate,
	 struct eval_result *res)
{
	struct eval_result tmp1, tmp2;
	double args[SLB_MAX_ARGS];
	int i;
	struct slb_node *np;
	
	switch (node->n_type) {
	case node_unknown:
		abort();
		
	case node_variable:
		res->type = EVT_NUMBER;
		res->v.number = node->v.n_var->vr_inst->vi_value;
		break;
		
	case node_const:
		res->type = EVT_NUMBER;
		res->v.number = node->v.n_const;
		break;
		
	case node_uminus:
		if (evalnode(node->v.n_arg[0], pstate, &tmp1))
			return 1;
		res->type = EVT_NUMBER;
		res->v.number = - to_number(&tmp1);
		break;
		
	case node_add:
		if (evalnode(node->v.n_arg[0], pstate, &tmp1))
			return 1;
		if (evalnode(node->v.n_arg[1], pstate, &tmp2))
			return 1;
		res->type = EVT_NUMBER;
		res->v.number = to_number(&tmp1) + to_number(&tmp2);
		break;
		
	case node_sub:
		if (evalnode(node->v.n_arg[0], pstate, &tmp1))
			return 1;
		if (evalnode(node->v.n_arg[1], pstate, &tmp2))
			return 1;
		res->type = EVT_NUMBER;
		res->v.number = to_number(&tmp1) + to_number(&tmp2);
		break;

	case node_mul:
		if (evalnode(node->v.n_arg[0], pstate, &tmp1))
			return 1;
		if (evalnode(node->v.n_arg[1], pstate, &tmp2))
			return 1;
		res->type = EVT_NUMBER;
		res->v.number = to_number(&tmp1) * to_number(&tmp2);
		break;
		
	case node_div:
		if (evalnode(node->v.n_arg[0], pstate, &tmp1))
			return 1;
		if (evalnode(node->v.n_arg[1], pstate, &tmp2))
			return 1;
		res->type = EVT_NUMBER;
		res->v.number = to_number(&tmp1) / to_number(&tmp2);
		break;

	case node_pow:
		if (evalnode(node->v.n_arg[0], pstate, &tmp1))
			return 1;
		if (evalnode(node->v.n_arg[1], pstate, &tmp2))
			return 1;
		res->type = EVT_NUMBER;
		res->v.number = pow(to_number(&tmp1), to_number(&tmp2));
		break;
		
	case node_or:
		res->type = EVT_BOOLEAN;
		if (evalnode(node->v.n_arg[0], pstate, &tmp1))
			return 1;
		if (!to_boolean(&tmp1)) {
			if (evalnode(node->v.n_arg[1], pstate, &tmp1))
				return 1;
		}
		res->v.boolean = to_boolean(&tmp1);
		break;
		
	case node_and:
		res->type = EVT_BOOLEAN;
		if (evalnode(node->v.n_arg[0], pstate, &tmp1))
			return 1;
		if (to_boolean(&tmp1)) {
			if (evalnode(node->v.n_arg[1], pstate, &tmp1))
				return 1;
		}
		res->v.boolean = to_boolean(&tmp1);
		break;
		
	case node_not:
		res->type = EVT_BOOLEAN;
		if (evalnode(node->v.n_arg[0], pstate, &tmp1))
			return 1;
		res->v.boolean = !to_boolean(&tmp1);
		break;
		
	case node_eq:
		res->type = EVT_BOOLEAN;
		if (evalnode(node->v.n_arg[0], pstate, &tmp1))
			return 1;
		if (evalnode(node->v.n_arg[1], pstate, &tmp2))
			return 1;
		if (tmp1.type == tmp2.type) {
			switch (tmp1.type) {
			case EVT_BOOLEAN:
				res->v.boolean =
					tmp1.v.boolean == tmp2.v.boolean;
				break;

			case EVT_NUMBER:
				res->v.boolean =
					tmp1.v.number == tmp2.v.number;
			}
		} else
			res->v.boolean = to_number(&tmp1) == to_number(&tmp2);
		break;
		
	case node_ne:
		res->type = EVT_BOOLEAN;
		if (evalnode(node->v.n_arg[0], pstate, &tmp1))
			return 1;
		if (evalnode(node->v.n_arg[1], pstate, &tmp2))
			return 1;
		if (tmp1.type == tmp2.type) {
			switch (tmp1.type) {
			case EVT_BOOLEAN:
				res->v.boolean =
					tmp1.v.boolean != tmp2.v.boolean;
				break;

			case EVT_NUMBER:
				res->v.boolean =
					tmp1.v.number != tmp2.v.number;
			}
		} else
			res->v.boolean = to_number(&tmp1) != to_number(&tmp2);
		break;

 	case node_lt:
		res->type = EVT_BOOLEAN;
		if (evalnode(node->v.n_arg[0], pstate, &tmp1))
			return 1;
		if (evalnode(node->v.n_arg[1], pstate, &tmp2))
			return 1;
		if (tmp1.type == tmp2.type) {
			switch (tmp1.type) {
			case EVT_BOOLEAN:
				res->v.boolean =
					tmp1.v.boolean < tmp2.v.boolean;
				break;

			case EVT_NUMBER:
				res->v.boolean = tmp1.v.number < tmp2.v.number;
			}
		} else
			res->v.boolean = to_number(&tmp1) < to_number(&tmp2);
		break;
		
	case node_le:
		res->type = EVT_BOOLEAN;
		if (evalnode(node->v.n_arg[0], pstate, &tmp1))
			return 1;
		if (evalnode(node->v.n_arg[1], pstate, &tmp2))
			return 1;
		if (tmp1.type == tmp2.type) {
			switch (tmp1.type) {
			case EVT_BOOLEAN:
				res->v.boolean =
					tmp1.v.boolean <= tmp2.v.boolean;
				break;

			case EVT_NUMBER:
				res->v.boolean =
					tmp1.v.number <= tmp2.v.number;
			}
		} else
			res->v.boolean = to_number(&tmp1) <= to_number(&tmp2);
		break;
		
	case node_gt:
		res->type = EVT_BOOLEAN;
		if (evalnode(node->v.n_arg[0], pstate, &tmp1))
			return 1;
		if (evalnode(node->v.n_arg[1], pstate, &tmp2))
			return 1;
		if (tmp1.type == tmp2.type) {
			switch (tmp1.type) {
			case EVT_BOOLEAN:
				res->v.boolean =
					tmp1.v.boolean > tmp2.v.boolean;
				break;

			case EVT_NUMBER:
				res->v.boolean =
					tmp1.v.number > tmp2.v.number;
			}
		} else
			res->v.boolean = to_number(&tmp1) > to_number(&tmp2);
		break;
		
	case node_ge:
		res->type = EVT_BOOLEAN;
		if (evalnode(node->v.n_arg[0], pstate, &tmp1))
			return 1;
		if (evalnode(node->v.n_arg[1], pstate, &tmp2))
			return 1;
		if (tmp1.type == tmp2.type) {
			switch (tmp1.type) {
			case EVT_BOOLEAN:
				res->v.boolean =
					tmp1.v.boolean >= tmp2.v.boolean;
				break;

			case EVT_NUMBER:
				res->v.boolean =
					tmp1.v.number >= tmp2.v.number;
			}
		} else
			res->v.boolean = to_number(&tmp1) >= to_number(&tmp2);
		break;
		
	case node_cond:
		if (evalnode(node->v.n_arg[0], pstate, &tmp1))
			return 1;
		if (to_boolean(&tmp1)) {
			if (node->v.n_arg[1]) {
				if (evalnode(node->v.n_arg[1], pstate, res))
					return 1;
			} else
				*res = tmp1;
		} else {
			if (evalnode(node->v.n_arg[2], pstate, res))
				return 1;
		}
		break;

	case node_func:
		for (i = 0, np = node->v.n_func.args; np;
		     i++, np = np->n_next) {
			if (evalnode(np, pstate, &tmp1))
				return 1;
			args[i] = to_number(&tmp1);
		}

		if (node->v.n_func.func(pstate, node, node->v.n_func.nargs,
					args, &res->v.number))
			return 1;
		res->type = EVT_NUMBER;
		break;

	case node_subexpr:
		if (evalnode(node->v.n_expr.expr->ex_tree, pstate, res))
			return 1;
		break;

	case node_asgn:
		if (evalnode(node->v.n_asgn.expr, pstate, res))
			return 1;
		node->v.n_asgn.var->vr_inst->vi_value = to_number(res);
		break;

	case node_list:
		for (np = node->n_next; np; np = np->n_next) {
			if (evalnode(np, pstate, res))
				return 1;
		}
	}
	return 0;
}

static int
_print_arg(void *item, void *data)
{
	struct slb_varref *vr = item;

	debug_printf("%s=%g", vr->vr_sym.name, vr->vr_inst->vi_value);
	return 0;
}

int
eval_expression(struct slb_expression *expr, struct slb_node_state **pstate,
		double *pnum)
{
	struct eval_result res;

	if (debug_level[SLB_DEBCAT_EVAL] >= 2) {
		debug_printf("evaluating expression \"%s\"", expr->ex_text);
		debug_printf("input arguments:");
		grecs_symtab_enumerate(expr->ex_vartab, _print_arg, NULL);
	}
	
	if (evalnode(expr->ex_tree, pstate, &res)) {
		debug(SLB_DEBCAT_EVAL, 1,
		      ("failure evaluating expression \"%s\"",
		       expr->ex_text));
		return 1;
	}
	*pnum = to_number(&res);
	debug(SLB_DEBCAT_EVAL, 2, ("expression yields %g", *pnum));
	if (expr->ex_eval_count < expr->ex_min_eval) {
		debug(SLB_DEBCAT_EVAL, 1,
		      ("temporary failure evaluating expression \"%s\": "
		       "minimal eval count not reached (%d < %d)",
		       expr->ex_text,
		       expr->ex_eval_count, expr->ex_min_eval));
		++expr->ex_eval_count;
		return 1;
	}
	return 0;
}
	
	
struct slb_node *
copy_node(struct slb_node *node, struct grecs_symtab *vartab)
{
	struct slb_node *new_node, *tail, *np;

	if (!node)
		return NULL;
	
	new_node = alloc_node(node->n_locus.beg, node->n_locus.end);

	new_node->n_type = node->n_type;
	new_node->n_min_eval = node->n_min_eval;
	switch (node->n_type) {
	case node_unknown:
		abort();
		
	case node_variable: {
		int install = 1;
		new_node->v.n_var = varref_lookupz(vartab,
						   node->v.n_var->vr_sym.name,
						   &install);
		break;
	}
		
	case node_uminus:
	case node_not:
		new_node->v.n_arg[0] = copy_node(node->v.n_arg[0], vartab);
		break;
		
	case node_add:
	case node_sub:
	case node_mul:
	case node_div:
	case node_or:
	case node_and:
	case node_eq:
	case node_ne:
 	case node_lt:
	case node_le:
	case node_gt:
	case node_ge:
	case node_pow:
		new_node->v.n_arg[0] = copy_node(node->v.n_arg[0], vartab);
		new_node->v.n_arg[1] = copy_node(node->v.n_arg[1], vartab);
		break;
		
	case node_cond:
		new_node->v.n_arg[0] = copy_node(node->v.n_arg[0], vartab);
		new_node->v.n_arg[1] = copy_node(node->v.n_arg[1], vartab);
		new_node->v.n_arg[2] = copy_node(node->v.n_arg[2], vartab);
		break;

	case node_func:
		new_node->v.n_func.func = node->v.n_func.func;
		new_node->v.n_func.nargs = node->v.n_func.nargs;
		tail = NULL;
		for (np = node->v.n_func.args; np; np = np->n_next) {
			struct slb_node *nnp = copy_node(np, vartab);
			if (tail)
				tail->n_next = nnp;
			else
				new_node->v.n_func.args = nnp;
			tail = nnp;
		}
		break;

	case node_subexpr:
		/* FIXME: copy_expression? */
		memcpy(&new_node->v, &node->v, sizeof(new_node->v));
		break;

	case node_const:
		memcpy(&new_node->v, &node->v, sizeof(new_node->v));
		break;

	case node_asgn: {
		int install = 1;
		new_node->v.n_asgn.var =
			varref_lookupz(vartab,
				       node->v.n_asgn.var->vr_sym.name,
				       &install);
		new_node->v.n_asgn.expr = copy_node(node->v.n_asgn.expr,
						    vartab);
		break;
	}

	case node_list:
		tail = NULL;
		for (np = node->n_next; np; np = np->n_next) {
			struct slb_node *node = copy_node(np, vartab);
			if (!tail)
				new_node->n_next = node;
			else
				tail->n_next = node;
			tail = node;
		}
	}

	return new_node;
}


